#!/usr/bin/env python2.5
#
# json dbus bridge examples
#
# Copyright (c) 2010 by Michael Olbrich <m.olbrich@pengutronix.de>
#
# To the extent possible under law, Pengutronix e.K. has waived all copyright
# and related or neighboring rights to JSON-DBus-Bridge Demo Code.
#


import gobject

import dbus
import dbus.service
import dbus.mainloop.glib


class Service(dbus.service.Object):
	def __init__(self):
		busname = dbus.service.BusName("com.pengutronix.jdb.Hello", dbus.SessionBus())
		dbus.service.Object.__init__(self, None, "/", busname)


	@dbus.service.method("com.pengutronix.jdb.Hello",
		in_signature='', out_signature='s')
	def HelloWorld(self):
		return "Hello World!"

	@dbus.service.method("com.pengutronix.jdb.Hello",
		in_signature='s', out_signature='s')
	def Echo(self, text):
		return text

	@dbus.service.method("com.pengutronix.jdb.Hello",
		in_signature='', out_signature='s')
	def HelloUser(self):
		return "Hello User!"

	@dbus.service.method("com.pengutronix.jdb.Hello",
		in_signature='', out_signature='s')
	def HelloAdmin(self):
		return "Hello Admin!"

dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)

object = Service()

mainloop = gobject.MainLoop()
mainloop.run()

